mainprint = "";

function search_and_destroy(node)
{
	if(!node.nodeName) {node = load_xml(node);}

	switch(node.nodeName)
	{
		// Default crap in the XML object that should break the switch, otherwise they will display stuff that they shouldn't.
		case "#document":	break;
		case "xml":		break;
		case "xml-stylesheet":	break;

		case "#text":
			mainprint += node.text;
			break;

		case "calendar":
			mainprint += '<div id="cal_goes_here"></div>';
			break;

		case "clock":
			mainprint += '<table class="clock_box" cellspacing="0" cellpadding="0"><tr><td><div id="clock_goes_here">&nbsp;</div></td></tr></table>';
			break;

		case "cmdbox":
			mainprint += '<input type="text" id="cmdbox" class="cmdbox"/><input type="button" value="Go!" onclick="execute(cmdbox.value);" class="cmdbox_button/>';
			break;

		case "desktop":
			if(node.getAttribute("refresh"))
			{
				time = node.getAttribute("refresh") * 60000;
				setTimeout("location.reload()", time);
			}
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			return;

		case "dot":
			mainprint += '<table border="0" cellspacing="0" cellpadding="0" style="background-color:'+node.getAttribute("color")+'; width:'+node.getAttribute("width")+'; height:'+node.getAttribute("height")+';"><tr><td></td></tr></table>';
			break;

		case "edit":
			mainprint += '<a target="_self" href="javascript:edit_self();">';
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;

		case "folder":
			mainprint += '<a target="_self" href="javascript:;" onclick="explore(\'' + node.getAttribute("path") + '\')">';
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;

		case "menu":
			if(node.getAttribute("name"))
			{
				// some stupid hack to get the title before the maximize image
				mainprint += '<table cellspacing="0" cellpadding="0"><tr><td width="100%"><font class="title">';

				if(node.childNodes.item(0).nodeName == "title")
				{
					for(var i = 0 ; i < node.childNodes.item(0).childNodes.length ; i++)
					{
						search_and_destroy(node.childNodes.item(0).childNodes.item(i));
					}

					mainprint += '</font></td><td><img src="images/maximize.gif" onclick="toggle('+node.getAttribute("name")+',this);" onload="get_vis_status('+node.getAttribute("name")+',this);" class="min_max_image" style="filter:progid:DXImageTransform.Microsoft.BasicImage(rotation=0);"></td></tr></table><span id="'+node.getAttribute("name")+'" style="display:none;">';

					for(var i = 0 ; i < node.childNodes.length ; i++)
					{
						search_and_destroy(node.childNodes.item(i));
					}

					mainprint += '</span>';
				}
				else
				{
					mainprint += 'No &lt;title&gt;&lt/title&gt; in menu: '+node.getAttribute("name")+'</font></td></tr></table>';
				}
			}
			else
			{
				mainprint += 'Menu name required!';
			}
			return;

		case "network":
			mainprint += '<a target="_self" href="javascript:;" onclick="open_network();">';
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;

		case "notepad":
			if(node.getAttribute("name"))
			{
				if(node.getAttribute("type") == "single")
				{
					mainprint += '<input type="text" onchange="write_file(rootpath + \'notes\\\\\' + '+node.getAttribute("name")+'.id + \'.txt\', this.value);" id="'+node.getAttribute("name")+'" class="'+node.getAttribute("class")+'"/><script type="text/javascript">load_notepad('+node.getAttribute("name")+');</script>';
				}
				else
				{
					mainprint += '<textarea onchange="write_file(rootpath + \'notes\\\\\' + '+node.getAttribute("name")+'.id + \'.txt\', this.value);" id="'+node.getAttribute("name")+'" class="'+node.getAttribute("class")+'"></textarea><script type="text/javascript">load_notepad('+node.getAttribute("name")+');</script>';
				}
			}
			else
			{
				mainprint += 'Notepad name required!';
			}
			break;

		case "program":
			if(node.getAttribute("switches"))
			{
				mainprint += '<a target="_self" href="javascript:;" onclick="execute(\'' + node.getAttribute("path") + '\', \''+node.getAttribute("switches")+'\')">';
			}
			else
			{
				mainprint += '<a target="_self" href="javascript:;" onclick="execute(\'' + node.getAttribute("path") + '\')">';
			}

			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;

		case "recycle_bin":
			mainprint += '<a target="_self" href="javascript:;" onclick="open_recycle_bin();">';
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;

		case "recycle_bin_empty":
			mainprint += '<a target="_self" href="javascript:;" onclick="execute(rootpath + \'empty_recycle_bin.exe\');">';
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;

		case "refresh":
			mainprint += '<a target="_self" href="javascript:;" onclick="refresh();">';
			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}
			mainprint += '</a>';
			return;
			

		case "section":
			mainprint += '<div style="position:absolute; ';
			if(node.getAttribute("left"))	{ mainprint += 'left:'	+ node.getAttribute("left")	+ ';'; }
			if(node.getAttribute("right"))	{ mainprint += 'right:'	+ node.getAttribute("right")	+ ';'; }
			if(node.getAttribute("bottom"))	{ mainprint += 'bottom:'+ node.getAttribute("bottom")	+ ';'; }
			if(node.getAttribute("top"))	{ mainprint += 'top:'	+ node.getAttribute("top")	+ ';'; }
			mainprint += '"><table cellpadding="0" cellspacing="0" width="' + node.getAttribute("width") + '"><tr><td>';

			for(var i = 0 ; i < node.childNodes.length ; i++)
			{
				search_and_destroy(node.childNodes.item(i));
			}

			mainprint += '</td></tr></table></div>';

			return;

		case "space":
			mainprint += "&nbsp;";
			return;

		case "title":
			return;

		case "toggle":
			if(node.getAttribute("name"))
			{
				mainprint += '<script onload="get_vis_status('+node.getAttribute("name")+');"></script><a target="_self" href="javascript:;" onclick="toggle('+node.getAttribute("name")+')">';
				for(var i = 0 ; i < node.childNodes.length ; i++)
				{
					search_and_destroy(node.childNodes.item(i));
				}
				mainprint += '</a>';
			}
			else
			{
				mainprint += "Toggle name required!";
			}
			return;

		case "togglethis":
			if(node.getAttribute("name"))
			{
				// Since <span> doesn't have onload="", I had to stick in an invisible image to check the visibility of the <span> when it's loaded. The image is what does the toggle check and sets the visibility of the <span> accordingly. Kind of a hack, I know, but it works. :P

				mainprint += '<span id="'+node.getAttribute("name")+'" style="display:none;"><img src="images/dot_clear.gif" width="100" height="100" onload="get_vis_status('+node.getAttribute("name")+');" style="display:none;">'
				for(var i = 0 ; i < node.childNodes.length ; i++)
				{
					search_and_destroy(node.childNodes.item(i));
				}
				mainprint += '</span>';
			}
			else
			{
				mainprint += "Togglethis name required!";
			}
			return;

		case "wallpaper":
			mainprint += '<span style="width:'+node.getAttribute("width")+';"><nobr/><center><select id="bg_chooser" size="1" ondblclick="bg_setbg(bg_chooser.value);"></select><br/><input id="bg_file" type="file"/><br/><input type="button" value="Add" onclick="bg_add(bg_file.value);"/><br/><input type="button" value="Remove" onclick="bg_remove(bg_chooser.value);"/><br/><input type="button" value="Set Wallpaper" onclick="bg_setbg(bg_chooser.value);bg_chooser.click();"/></center></nobr></span>';
			return;

		// A crap ton of weather related elements...

		case "weather":
			if(node.getAttribute("location"))
			{
				weatherfeed = load_xml("http://www.weatherroom.com/xml/ext/" + node.getAttribute("location"));

				if(weatherfeed)
				{
					current		= weatherfeed.childNodes.item(1).childNodes.item(0);
					forecast	= weatherfeed.childNodes.item(1).childNodes.item(1);

					for(var i = 0 ; i < node.childNodes.length ; i++)
					{
						search_and_destroy(node.childNodes.item(i));
					}
				}
				else{ mainprint += "<center>Disconnected</center>"; }
			}
			else
			{
				mainprint += "Weather location required!";
			}

			return;

		case "w_today_name":
			var daynames	= new Array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
			var todaycal	= new Date();
			var today	= todaycal.getDay();		// Returns day (0-6)

			weatherfeed ? mainprint += daynames[today] : mainprint += '';

			break;

		case "w_today_location":	if(current.xml)	{mainprint += current.childNodes.item(1).text;}				else{mainprint += '';}	break;
		case "w_today_conditions":	if(current.xml)	{mainprint += current.childNodes.item(6).text;}				else{mainprint += '';}	break;
		case "w_today_visibility":	if(current.xml)	{mainprint += current.childNodes.item(7).text;}				else{mainprint += '';}	break;
		case "w_today_temp":		if(current.xml)	{mainprint += current.childNodes.item(8).text;}				else{mainprint += '';}	break;
		case "w_today_humidity":	if(current.xml)	{mainprint += current.childNodes.item(9).text;}				else{mainprint += '';}	break;
		case "w_today_wind":		if(current.xml)	{mainprint += current.childNodes.item(10).text;}			else{mainprint += '';}	break;
		case "w_today_barometer":	if(current.xml)	{mainprint += current.childNodes.item(11).text;}			else{mainprint += '';}	break;
		case "w_today_dewpoint":	if(current.xml)	{mainprint += current.childNodes.item(12).text;}			else{mainprint += '';}	break;
		case "w_today_heatindex":	if(current.xml)	{mainprint += current.childNodes.item(13).text;}			else{mainprint += '';}	break;
		case "w_today_windchill":	if(current.xml)	{mainprint += current.childNodes.item(14).text;}			else{mainprint += '';}	break;
		case "w_today_sunrise":		if(current.xml)	{mainprint += current.childNodes.item(15).text;}			else{mainprint += '';}	break;
		case "w_today_sunset":		if(current.xml)	{mainprint += current.childNodes.item(16).text;}			else{mainprint += '';}	break;
		case "w_today_moonphase":	if(current.xml)	{mainprint += current.childNodes.item(17).text;}			else{mainprint += '';}	break;

		case "w_tonight_conditions":	if(forecast.xml){mainprint += forecast.childNodes.item(3).childNodes.item(0).text;}	else{mainprint += '';}	break;
		case "w_tonight_high":		if(forecast.xml){mainprint += forecast.childNodes.item(3).childNodes.item(1).text;}	else{mainprint += '';}	break;
		case "w_tonight_low":		if(forecast.xml){mainprint += forecast.childNodes.item(3).childNodes.item(2).text;}	else{mainprint += '';}	break;

		case "w_tomorrow_name":		if(forecast.xml){mainprint += forecast.childNodes.item(4).nodeName;}			else{mainprint += '';}	break;
		case "w_tomorrow_conditions":	if(forecast.xml){mainprint += forecast.childNodes.item(4).childNodes.item(0).text;}	else{mainprint += '';}	break;
		case "w_tomorrow_high":		if(forecast.xml){mainprint += forecast.childNodes.item(4).childNodes.item(1).text;}	else{mainprint += '';}	break;
		case "w_tomorrow_low":		if(forecast.xml){mainprint += forecast.childNodes.item(4).childNodes.item(2).text;}	else{mainprint += '';}	break;

		case "w_2_name":		if(forecast.xml){mainprint += forecast.childNodes.item(5).nodeName;}			else{mainprint += '';}	break;
		case "w_2_conditions":		if(forecast.xml){mainprint += forecast.childNodes.item(5).childNodes.item(0).text;}	else{mainprint += '';}	break;
		case "w_2_high":		if(forecast.xml){mainprint += forecast.childNodes.item(5).childNodes.item(1).text;}	else{mainprint += '';}	break;
		case "w_2_low":			if(forecast.xml){mainprint += forecast.childNodes.item(5).childNodes.item(2).text;}	else{mainprint += '';}	break;

		case "w_3_name":		if(forecast.xml){mainprint += forecast.childNodes.item(6).nodeName;}			else{mainprint += '';}	break;
		case "w_3_conditions":		if(forecast.xml){mainprint += forecast.childNodes.item(6).childNodes.item(0).text;}	else{mainprint += '';}	break;
		case "w_3_high":		if(forecast.xml){mainprint += forecast.childNodes.item(6).childNodes.item(1).text;}	else{mainprint += '';}	break;
		case "w_3_low":			if(forecast.xml){mainprint += forecast.childNodes.item(6).childNodes.item(2).text;}	else{mainprint += '';}	break;

		case "w_4_name":		if(forecast.xml){mainprint += forecast.childNodes.item(7).nodeName;}			else{mainprint += '';}	break;
		case "w_4_conditions":		if(forecast.xml){mainprint += forecast.childNodes.item(7).childNodes.item(0).text;}	else{mainprint += '';}	break;
		case "w_4_high":		if(forecast.xml){mainprint += forecast.childNodes.item(7).childNodes.item(1).text;}	else{mainprint += '';}	break;
		case "w_4_low":			if(forecast.xml){mainprint += forecast.childNodes.item(7).childNodes.item(2).text;}	else{mainprint += '';}	break;

		// Done with those weather elements finally. :P

		default:
			var booga = node.xml;
			var ooga = booga.split("<");	// Split by elements

			if(ooga.length > 2)	// Only do this recursion stuff if the element can have things in it, like <center></center> and not <br/>
			{
				ooga.shift();	// Get rid of the blank first array element created by the split

				for(var i=0; i<ooga.length; i++)
				{
					ooga[i] = "<" + ooga[i];	// Add < to make each element into an element again
				}

				mainprint += ooga[0];

				var middle_of_ooga = "";
				for(var i=1; i<ooga.length-1; i++)
				{
					middle_of_ooga += ooga[i];
				}

				var middle_of_ooga2 = "<childofdefault>" + middle_of_ooga + "</childofdefault>";

				var	harharhar = new ActiveXObject("Microsoft.XMLDOM");
					harharhar.async="false";
					harharhar.loadXML(middle_of_ooga2);

				for(var i = 0 ; i < harharhar.childNodes.item(0).childNodes.length ; i++)
				{
					search_and_destroy(harharhar.childNodes.item(0).childNodes.item(i));
				}

				mainprint += ooga[ooga.length-1];
				return;
			}
			else
			{
				mainprint += node.xml;
			}
	}

	for(var i = 0 ; i < node.childNodes.length ; i++)
	{
		search_and_destroy(node.childNodes.item(i));
	}

	return mainprint;
}